/*
 * Copyright 2022 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// VERSION: v0_117
// GENERATED CODE - DO NOT MODIFY BY HAND

package com.xayah.core.ui.material3.tokens

import androidx.compose.ui.unit.dp
import com.xayah.core.ui.theme.ThemedColorSchemeKeyTokens

internal object MenuTokens {
    val ContainerColor = ThemedColorSchemeKeyTokens.Surface
    val ContainerElevation = ElevationTokens.Level2
    val ContainerShape = ShapeKeyTokens.CornerExtraSmall
    val ContainerSurfaceTintLayerColor = ThemedColorSchemeKeyTokens.SurfaceTint
    val ListItemContainerHeight = 48.0.dp
    val ListItemDisabledLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    const val ListItemDisabledLabelTextOpacity = 0.38f
    val ListItemFocusLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val ListItemHoverLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val ListItemLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val ListItemLabelTextFont = TypographyKeyTokens.LabelLarge
    val ListItemPressedLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val ListItemSelectedContainerColor = ThemedColorSchemeKeyTokens.SurfaceVariant
    val ListItemDisabledLeadingIconColor = ThemedColorSchemeKeyTokens.OnSurface
    const val ListItemDisabledLeadingIconOpacity = 0.38f
    val ListItemLeadingFocusIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemLeadingHoverIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemLeadingIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemLeadingIconSize = 24.0.dp
    val ListItemLeadingPressedIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemDisabledTrailingIconColor = ThemedColorSchemeKeyTokens.OnSurface
    const val ListItemDisabledTrailingIconOpacity = 0.38f
    val ListItemTrailingFocusIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemTrailingHoverIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemTrailingPressedIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemTrailingIconColor = ThemedColorSchemeKeyTokens.OnSurfaceVariant
    val ListItemTrailingIconSize = 24.0.dp
}
