/*
 * Copyright 2023 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.xayah.core.ui.material3.tokens

import androidx.compose.ui.unit.dp
import com.xayah.core.ui.theme.ThemedColorSchemeKeyTokens

internal object OutlinedSegmentedButtonTokens {
    val ContainerHeight = 40.0.dp
    val DisabledIconColor = ThemedColorSchemeKeyTokens.OnSurface
    val DisabledIconOpacity = 0.38f
    val DisabledLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val DisabledLabelTextOpacity = 0.38f
    val DisabledOutlineColor = ThemedColorSchemeKeyTokens.OnSurface
    val DisabledOutlineOpacity = 0.12f
    val LabelTextFont = TypographyKeyTokens.LabelLarge
    val OutlineColor = ThemedColorSchemeKeyTokens.Outline
    val OutlineWidth = 1.0.dp
    val SelectedContainerColor = ThemedColorSchemeKeyTokens.SecondaryContainer
    val SelectedFocusIconColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val SelectedFocusLabelTextColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val SelectedHoverIconColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val SelectedHoverLabelTextColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val SelectedLabelTextColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val SelectedPressedIconColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val SelectedPressedLabelTextColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val SelectedIconColor = ThemedColorSchemeKeyTokens.OnSecondaryContainer
    val Shape = ShapeKeyTokens.CornerFull
    val UnselectedFocusIconColor = ThemedColorSchemeKeyTokens.OnSurface
    val UnselectedFocusLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val UnselectedHoverIconColor = ThemedColorSchemeKeyTokens.OnSurface
    val UnselectedHoverLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val UnselectedLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val UnselectedPressedIconColor = ThemedColorSchemeKeyTokens.OnSurface
    val UnselectedPressedLabelTextColor = ThemedColorSchemeKeyTokens.OnSurface
    val UnselectedIconColor = ThemedColorSchemeKeyTokens.OnSurface
    val IconSize = 18.0.dp
}
